<?php
require_once("table.php");
$is_admin_field = new int_field("is_admin", '0'); // TODO: BOOLEAN
$is_admin_field->set_permissions('admin');
$email_field
= new email_field("email", TRUE, '', '', 40);
$address_fields
= array(new str_field("address1", TRUE, '', '', 50),
	new str_field("address2", FALSE, '', '', 50),
	new str_field("city", TRUE, 'Cambridge', '', 32),
	new state_field("state", TRUE, 'CA', '', 2),
	new zip_field("zip", TRUE, '02139', '', 10),
	new str_field("country", TRUE, 'USA', '', 32),
	);
$phone_fields
= array(new phone_field("phone_home", FALSE),
	new phone_field("phone_work", FALSE),
	new phone_field("phone_cell", FALSE),
	);
$contact_fields
= cat(cat(array($email_field), $address_fields), $phone_fields);
$tables
= array("users" 
	 => new table("users", 
		      cat(cat(array(new email_field("email", TRUE, '', '', 50, TRUE, TRUE),
				    new password_field("password", TRUE),
				    new str_field("affiliation", FALSE, '', '', 40),
				    new name_field("first_name", TRUE, '', '', 32), 
				    new name_field("last_name", TRUE, '', '', 32), 
				    ),
			      cat($address_fields, $phone_fields)),
			  array($is_admin_field, 
				new url_field("homepage", FALSE),
				new str_field("bio", FALSE),
				new creation_date_field("joined"))),
		      array("email", "first_name", "last_name"),
		      'user',
		      'email'),
	"fans"
	=> new table("fans",
		     array(new email_field("email", TRUE),
			   new name_field("first_name", FALSE, '', '', 32),
			   new name_field("last_name", FALSE, '', '', 32),
			   ),
		     array("email", "first_name", "last_name"),
		     'user',
		     'email'),
	"venues" 
	 => new table("venues", 
		      cat(cat(array(new str_field("name", TRUE, '', '', 32)), $address_fields),
			  array(new phone_field("phone", FALSE), 
				new url_field("url", FALSE),
				new str_field("directions", FALSE)))
		      ),
	 "events" 
	 => new table("events", 
		      array(new name_field("name", TRUE, '', '', 80, TRUE, TRUE, TRUE), 
			    new symptr_field("venue", "venues", "name", FALSE),
			    new str_field("description", FALSE),
			    new date_field("start_date", FALSE),
			    new date_field("close_date", FALSE),
			    new time_field("start_time", FALSE),
			    new time_field("end_time", FALSE),
			    new date_field("opening_date", FALSE),
			    new time_field("opening_start", FALSE),
			    new time_field("opening_end", FALSE),
			    new pic_field("poster", FALSE),
			    new url_field("catalog", FALSE),
			    new url_field("video", FALSE),
			    )),
	 "news" 
	 => new table("news", 
		      array(new str_field("title", TRUE, '', '', 80, TRUE, TRUE, TRUE), 
			    new symptr_field("user", "users", "email", TRUE, '$username'),
			    new creation_date_field("created"),
			    new pic_field("pic", FALSE), 
			    new str_field("description", TRUE), 
			    )),
	 "submissions" 
	 => new table("submissions", 
		      array(new str_field("name", TRUE, '', '', 64, TRUE, TRUE, TRUE), 
			    new symptr_field("event", "events", "name", TRUE),
			    new symptr_field("artist", "users", "email", TRUE, '$username'),
			    new list_field("collaborators", "collaborators", "submission_id", "user"),
			    new str_field("year", TRUE, '2005', '', 4),
			    new str_field("media", TRUE, '', '', 64),
			    new str_field("dimensions", TRUE, 'WxLxH', '', 64),
			    new str_field("proposal", TRUE, '', "for us"),
			    new str_field("description", FALSE, '', "for the public in catalog"),
			    new str_field("placard", FALSE, '', "for the public"),
			    new pic_field("pic", FALSE),
			    new url_field("url", FALSE, '', "with pics/video"),
			    new str_field("status", TRUE, '', "Is this work completed?  If not, what are your plans and schedule for completion?"),
			    new str_field("maintenance", TRUE, '', "How long will it run without intervention/what kind of maintenance does it need?"),
			    new str_field("automation", TRUE, '', "What does it take to startup and shutdown the piece every day?"),
			    new str_field("sound", TRUE, '', "What kind of sound does the piece produce? Does it require a quiet environment?"),
			    new str_field("light", TRUE, '', "What kind of light does the piece produce?  Does it require a light or dark environment?"),
			    new str_field("needs", TRUE, '', "Hanging, tables, barriers, etc."),
			    new str_field("safety", TRUE, '', " Is the work a potential safety hazard (gas, fire, water, chemicals, projectiles, etc.)?"),
			    new creation_date_field("submitted"),
			    ),
		      array("name", "event", "artist", "pic"),
		      'user',
		      'artist',
		      FALSE),
	 "collaborators" 
	 => new table("collaborators", 
	 	      array(new symptr_field("submission", "submissions", "name"), 
	 		    new symptr_field("user", "users", "email")
	 		    )),
	 "talks" 
	 => new table("talks", 
		      array(new str_field("title", TRUE, '', '', 64),
			    new symptr_field("user", "users", "email"),
			    new str_field("description"),
			    new symptr_field("venue", "venues", "name"),
			    new datetime_field("datetime"),
			    new url_field("url", FALSE)
			    )),
	   );
?>
